/*
 * $Id: MessageListener.java,v 1.1 2003/09/06 21:49:21 wurp Exp $
 * $Log: MessageListener.java,v $
 * Revision 1.1  2003/09/06 21:49:21  wurp
 * Migrated stuff from ARMI into here
 *
 * Revision 1.1  2003/08/18 17:12:42  gergiskhan
 * Refactoring.  Changed package structure.
 *
 * Revision 1.1  2003/08/08 02:17:20  gergiskhan
 * no message
 *
 * Revision 1.1.1.1  2001/06/26 00:55:25  wurp
 * importing initial rev of source
 *
 * Revision 1.2  2001/06/20 03:36:06  wurp
 * added log4j.
 * debugging character creation issues.
 *
 * Revision 1.1  2001/04/06 05:33:08  wurp
 * Reorganized networking code
 *
 * Revision 1.1  2001/03/19 01:51:31  wurp
 * Adding new Asynchronous Messaging system.  Needs more testing, but superficial
 * tests show it working.
 *
 */

package com.navtools.armi.networking;

import org.apache.log4j.Category;

public interface MessageListener
{
	public static final Category LOG =
	Category.getInstance( MessageListener.class.getName() );

	/**
	 * Processes the message in some arbitrary way.
	 * @param msg the message to process
	 * @return whether or not the message was consumed
	 */
	public boolean processMessage( Message msg );
}
