/*
 * $Id: Prototype.java,v 1.2 2003/09/06 21:49:22 wurp Exp $
 * $Log: Prototype.java,v $
 * Revision 1.2  2003/09/06 21:49:22  wurp
 * Migrated stuff from ARMI into here
 *
 * Revision 1.1  2003/08/18 17:12:42  gergiskhan
 * Refactoring.  Changed package structure.
 *
 * Revision 1.1  2003/08/08 02:17:21  gergiskhan
 * no message
 *
 * Revision 1.1.1.1  2001/06/26 00:55:49  wurp
 * importing initial rev of source
 *
 * Revision 1.2  2001/06/20 02:58:52  wurp
 * Updated to log4j.  Added default ctor to CharacterInfo
 *
 * Revision 1.1  2001/03/21 01:03:04  wurp
 * Integrated new networking code with client and server.  Still need to do massive
 * cleanup.
 *
 */

package com.navtools.util;

import org.apache.log4j.Category;

public interface Prototype
{
	public static final Category LOG =
	Category.getInstance( Prototype.class.getName() );

	/**
	 * Prototype classes should override this method to return an instance
	 * as it would be if constructed by a default constructor.
	 * Typically is implemented with simply:
	 * return new PrototypeSubclass();
	 * @return new default instance
	 */
	public Prototype defaultInstance();
}
